#!/usr/bin/env perl
system('/usr/bin/env perl -V > perlv_output');
if(!open(INFILE,"perlv_output")){die "Can't open input file";}
if(!open(OUTFILE,">makefile_include")){die "Can't open output file";}
$path=0;
$path2=1;
while (<INFILE>)
{
  if(m/ ldflags =(.*)/){
    $_=$1;
    s/'//g;
    print OUTFILE "MAP_LINKCMD = \$(CC) ".$_."\n";
  }
  
if(m/libperl=(.*)/){
    if((substr($1,0,7) eq "libperl")){
       print OUTFILE "LIBPERL = ".$1."\n";
       print OUTFILE "MAP_LIBPERL = \$(PERL_INC)\/".$1."\n";
    }
    else
    {
       print OUTFILE "LIBPERL = libperl.so\n";
       print OUTFILE "MAP_LIBPERL = \$(PERL_INC)\/libperl.so\n";
    } 
  }


  if(m/\Wlibs=(.*)/){
    print OUTFILE "MAP_PRELIBS = ".$1."\n";
  }

  if(m/libpth=(.*)/){
    $_=$1;
    @libpth=split(/ /,$_); 
     print OUTFILE "LIBPTH = ";
    while (@libpth != NULL){
     $libpth2=pop(@libpth);
     print OUTFILE "-L".$libpth2." ";
    }
     print OUTFILE "\n";
  }

  if(m/osname=solaris/)
  {
    print OUTFILE "CC = cc\n";
    print OUTFILE "SO = so\n";
    #LDLDFLAGS = SO_DLFLAGS
    print OUTFILE "LDDLFLAGS = -G\n";
    print OUTFILE "OPTIMIZE = -xO4\n";
    print OUTFILE "LD =ld\n";
    print OUTFILE "DLEXT = so\n";
    print OUTFILE "DLSRC = dl_dlopen.xs\n";
    print OUTFILE "CCCDLFLAGS = -KPIC -xarch=generic\n";
    print OUTFILE "RANLIB = : \n"
  }
 if(m/osname=linux/)
  {
    print OUTFILE "CC = gcc\n";
    print OUTFILE "SO = so\n";
    #LDLDFLAGS = SO_DLFLAGS
    print OUTFILE "LDDLFLAGS = -shared\n";
    print OUTFILE "OPTIMIZE = -O3\n";
    print OUTFILE "LD =ld\n";
    print OUTFILE "DLEXT = so\n";
    print OUTFILE "DLSRC = dl_dlopen.xs\n";
    print OUTFILE "CCCDLFLAGS = \n";
    print OUTFILE "RANLIB = : \n"
  }
  if(m/osname=darwin/)
  {
    print OUTFILE "CC = cc\n";
    print OUTFILE "SO = dylib\n";
    #LDLDFLAGS = SO_DLFLAGS
    print OUTFILE "LDDLFLAGS = -bundle\n";
    print OUTFILE "OPTIMIZE = -O3\n";
    print OUTFILE "LD =ld\n";
    print OUTFILE "DLEXT = bundle\n";
    print OUTFILE "DLSRC = dl_dyld.xs\n";
    print OUTFILE "EXLIBS = /System/Library/Frameworks/IOKit.framework/Versions/A/IOKit /System/Library/Frameworks/CoreFoundation.framework/Versions/A/CoreFoundation\n";
    print OUTFILE "CCCDLFLAGS = -Wall\n";
    print OUTFILE "RANLIB = ranlib\n"
  }
  if(m/osname=irix/)
  {
    print OUTFILE "CC = cc\n";
    print OUTFILE "SO = so\n";
    #LDLDFLAGS = SO_DLFLAGS
    print OUTFILE "LDDLFLAGS = -shared\n";
    print OUTFILE "OPTIMIZE = -O2 -woff 1506\n";
    print OUTFILE "LD =ld\n";
    print OUTFILE "DLEXT = so\n";
    print OUTFILE "DLSRC = dl_dlopen.xs\n";
    print OUTFILE "CCCDLFLAGS = -n32 -mips3\n";
    print OUTFILE "RANLIB = : \n"
  }
 if(m/ENV/)
{ 
  $path2=0;
  $path=-2;
  next;
}
  elsif((m/\@INC/) && ($path2 == 0))
{ 
  $path=0;
  next;
}
  elsif((m/\@INC/) && ($path2 != 0))
{ 
  $path=1;
  next;
}

 $path++;
 if ($path == 2)
{
 chop($_);
 $perlarchlib=$_;
}
 if ($path == 3)
{
 chop($_);
 $perllib=$_;
}
 if ($path == 4)
{
 $sitelibexp=$_;
}
 if ($path == 5)
{
 $sitelibexp=$_;
}
 if ($path == 6)
{
 $sitearchexp=$_;
}
}
print OUTFILE "PERL_LIB = ".$perllib."\n";
print OUTFILE "PERL_ARCHLIB = ".$perlarchlib."\n";
print OUTFILE "SITEARCHEXP = ".$sitearchexp;
print OUTFILE "SITELIBEXP = ".$sitelibexp;
print OUTFILE "XSUBPPDIR = ".$perllib."/ExtUtils\n";
print OUTFILE "PERL_INC = ".$perlarchlib."/CORE";
print OUTFILE "\n";
`rm perlv_output`; 
